// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_glean_Pings_h
#define mozilla_glean_Pings_h

#include "glean/metrictypes.h"

#include <QObject>

// This class is not meant to be used directly.
// It is exposed as a singleton to QML.
//
// The reason for this is to keep consistency with the Glean API on m-c.
// On JavaScript pings are accessed through GleanPings.<MyPing> and
// on C++ they are accessed through mozilla::glean_pings::<MyPing>.
class __DONOTUSE__GleanPings final : public QObject {
    Q_OBJECT
    Q_DISABLE_COPY_MOVE(__DONOTUSE__GleanPings)

    Q_PROPERTY(Ping* Daemonsession READ DaemonsessionGetter CONSTANT)
    Q_PROPERTY(Ping* Main READ MainGetter CONSTANT)
    Q_PROPERTY(Ping* Vpnsession READ VpnsessionGetter CONSTANT)

    private:
        __DONOTUSE__GleanPings() = default;

    public:
        ~__DONOTUSE__GleanPings() = default;

        static __DONOTUSE__GleanPings* instance() {
            if (!s_instance) {
                s_instance = new __DONOTUSE__GleanPings();
            }

            return s_instance;
        }

        Ping* DaemonsessionGetter () { return &m_daemonsession; };
        const Ping& Daemonsession () const { return m_daemonsession; };
        Ping* MainGetter () { return &m_main; };
        const Ping& Main () const { return m_main; };
        Ping* VpnsessionGetter () { return &m_vpnsession; };
        const Ping& Vpnsession () const { return m_vpnsession; };

    private:
        Ping m_daemonsession = Ping(1);
        Ping m_main = Ping(2);
        Ping m_vpnsession = Ping(3);

        inline static __DONOTUSE__GleanPings* s_instance = nullptr;
};

namespace mozilla::glean_pings {
    /*
     * Generated from daemonsession.
     *
     * Only on iOS and Android.
 * Data for VPN sessions, as recorded from the Android daemon and
 * iOS Network Extension. This ping will record start/end datestamp,
 * session-based metrics, etc.
     */
    inline const Ping& Daemonsession = __DONOTUSE__GleanPings::instance()->Daemonsession();
    /*
     * Generated from main.
     *
     * A simple ping to send glean events generated by the Mozilla Cuddlefish apps.
     */
    inline const Ping& Main = __DONOTUSE__GleanPings::instance()->Main();
    /*
     * Generated from vpnsession.
     *
     * Data for one VPN session, defined as a user turning on and eventually
 * turning off the VPN in the app. This ping will record start/end datestamp,
 * session-based metrics, etc.
     */
    inline const Ping& Vpnsession = __DONOTUSE__GleanPings::instance()->Vpnsession();
} // namespace mozilla::glean_pings

#endif  // mozilla_glean_Pings_h
